import GameLogic
import socket
import OSC
import operator

# Get controller and owner
controller = GameLogic.getCurrentController()
owner = controller.owner

# Set init
ip = '127.0.0.1'
port = 9000
data_1 = 0

# Set
attribution = GameLogic.attribution
wii1 = []
btn_exist = GameLogic.btn_exist
ir=GameLogic.ir

# Connect Blender on socket 1
if not owner['connected_1']:
    owner['connected_1'] = True
    GameLogic.socket_1 = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    GameLogic.socket_1.bind((ip, port))
    GameLogic.socket_1.setblocking(0)
    GameLogic.socket_1.settimeout(0.01)
    # Set Buffer size
    # GameLogic.socket_1.setsockopt(level, optname, value)
    GameLogic.socket_1.setsockopt(socket.SOL_SOCKET, socket.SO_RCVBUF, 1024)

# If Blender connected
else:
    try:
        data_1, port = GameLogic.socket_1.recvfrom(1024)
        wii1 = OSC.decodeOSC(data_1)
    except socket.error:
        pass

# Set data in GameLogic
for i in range(len(wii1)-2):
    for key, value in attribution.items():
        if wii1[i+2][0]==key and wii1[i+2][1]!=',' and wii1[i+2][1]!='/all-data' and wii1[i+2][1]!='/btn_dict':
            setattr(GameLogic, value, wii1[i+2][2])
        # ir ---------------------------------------------------#
        if wii1[i+2][0] == '/ir' and wii1[i+2][1]!=',':
            irwii=wii1[i+2][2:]
            if len(irwii)!=0:
                for u in range(int(len(irwii)/2)):
                    ir[u]= [irwii[u],irwii[u+1]]
            GameLogic.ir=ir
        # btn --------------------------------------------------#
        if wii1[i+2][0] == '/btn_dict':
            # Transform list to dict
            btn_dict = dict([(k,v) for k,v in zip(wii1[i+2][::2], wii1[i+2][1::2])])
            for key, value in btn_dict.items():
                setattr(GameLogic, key, value)

        # cumul ---------−−−------------------------------------#
        if wii1[i+2][0] == '/all-data':
            GameLogic.allData = wii1[i+2][2:]
